/**************************************
 * $Author: kaneda $
 * $Date: 2003/01/18 10:50:11 $
 **************************************/

/* addr.h */

#ifndef __PH_ADDR_H__
#define __PH_ADDR_H__

#include "ph_util.h"


/* Structures */


/* ph_addr_type_t is ...*/
enum ph_addr_type {
  tcp = 0,
  ssh = 1,
  unknown = 2
};

typedef enum ph_addr_type 	ph_addr_type_t;



/* ph_addr_t is ...*/
struct ph_addr {
  char * 		host;		/* host (for debug) */ 
  char * 		service;	/* service (e.g., port number) */
  ph_addr_type_t 	type;

  char * 		user;		/* only for SSH */
};

typedef struct ph_addr	* ph_addr_t;

PH_DEFINE_LIST_STRUCTURE(ph_addr) 



/* Public Function Prototypes */
ph_addr_t ph_addr_new(char * host, char * service, ph_addr_type_t type, char * user);
void ph_addr_dispose(ph_addr_t addr);
ph_addr_t ph_addr_dup(ph_addr_t addr);
char * ph_addr_get_host(char * addr, int service, int listen_port);


PH_DEFINE_LIST_FUNC_PROTOTYPE(ph_addr) 


void ph_addr_list_print(ph_addr_list_t addr_list);
ph_addr_cell_t ph_addr_list_init_loop(ph_addr_list_t addr_list);
ph_addr_cell_t ph_addr_list_iterate(ph_addr_list_t addr_list, ph_addr_cell_t p);


#endif


