#ifndef __PH_VIEWER_H__
#define __PH_VIEWER_H__


#include "ph_pt2pt.h"

#include <X11/Xlib.h>
#include <X11/Xutil.h>



#define N_WINDOWS		1
#define N_GCS			1
#define WINDOW_WIDTH		512
#define WINDOW_HEIGHT		512

struct vinfo {
  ph_conn_t		 	conn;	/* accepted port */

  char				host[100];
  char				port[100];
  char				comment[100];
  int 				x, y;

  ph_vp_set_t			vp_set;
  ph_vp_set_t			reachable_vp_set;
  ph_routing_entry_list_t 	entry_list;
  ph_msg_list_t 		msg_list;
};


typedef struct vinfo	* vinfo_t;


PH_DEFINE_LIST_STRUCTURE(vinfo) 


struct viewer {
  vinfo_list_t		vinfo_list;
  ph_conn_t		listen_conn;

  /* for Xwindow */
  Display 	* display;		/* display pointer */
  Window 	windows[N_WINDOWS];	/* window ID */
  GC 		gcs[N_GCS];		/* graphic context */
  Font font;				/* loaded font */
};

typedef struct viewer	* viewer_t;


vinfo_t vinfo_new(ph_conn_t conn);
void vinfo_dispose(vinfo_t vinfo);
vinfo_t vinfo_new2(ph_conn_t conn, char * body);

void vinfo_vinfo2str(vinfo_t vinfo, char * s, size_t len);
int vinfo_compare(vinfo_t p, vinfo_t q);
int vinfo_is_connect(vinfo_t p, vinfo_t q);

void initialize_X(viewer_t viewer);
void finalize_X(viewer_t viewer);
void redraw(viewer_t viewer);

viewer_t viewer_new(int listen_port);
void viewer_dispose(viewer_t viewer);


PH_DEFINE_LIST_FUNC_PROTOTYPE(vinfo) 


#endif
