/**************************************
 * $Author: kaneda $
 * $Date: 2002/12/20 10:14:40 $
 **************************************/

/* vpgd.h */


#ifndef __VPGD_H__
#define __VPGD_H__

#include "util.h"
#include "conn.h"
#include "task.h"
#include "msg.h"


enum {
  RECEIVER_TIMEOUT	= 5,
  DEFAULT_PH_PORT	= 30000,
  DEFAULT_SH_PORT	= 30010
};


struct vpgd {
  char *		nickname;
  ph_vps_t		vps;

  task_list_t		tasks;

  conn_list_t		conns;
  msg_list_t		msgs;

  int	 		listen_port;
};


typedef struct vpgd	* vpgd_t;



/* Following functions are defined in vpgd.c */
vpgd_t vpgd_new(char * nickname, int listen_port);
void vpgd_dispose(vpgd_t vpgd);
void vpgd_print(vpgd_t vpgd);
ph_vp_t vpgd_get_host_vp(vpgd_t vpgd);

ph_vp_t nickname2vp(char * s);
void vp2nickname(ph_vp_t vp, char * s, size_t len);


/* Following functions are defined in exec.c */
void spawn_task(vpgd_t vpgd, task_t task);
void release_zombie_tasks(vpgd_t vpgd);


/* Following functions are defined in header.c */
void handle_msg(vpgd_t vpgd, msg_t msg, conn_t conn);
void handle_accept(vpgd_t vpgd, conn_t conn, fd_set * r_fdset_p);
void handle_recv(vpgd_t vpgd, conn_t conn, fd_set * r_fdset_p);
void handle_error(vpgd_t vpgd, conn_t conn, fd_set * e_fdset_p);


/* Following functions are defined in pt2pt.c */
void receiver(vpgd_t vpgd);


#endif


